diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/traced/traced-callback-typedef-test-suite.cc ns-3.38/src/test/traced/traced-callback-typedef-test-suite.cc
--- ns-3.37/src/test/traced/traced-callback-typedef-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/traced/traced-callback-typedef-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -143,7 +143,7 @@
 /**
  * \ingroup system-tests-traced
  *
- * Returns a sting representing the type of a class.
+ * Returns a string representing the type of a class.
  */
 #define TYPENAME(T)                                                                                \
     template <>                                                                                    \
@@ -249,7 +249,7 @@
   public:
     /**
      * \brief Sink function, called by a TracedCallback.
-     * \tparam Ts prameters of the TracedCallback.
+     * \tparam Ts parameters of the TracedCallback.
      */
     static void Sink(Ts...)
     {
@@ -325,7 +325,7 @@
 /**
  * \ingroup system-tests-traced
  *
- * Check the TracedCallback duplicate by checking if it maches the TracedCallback
+ * Check the TracedCallback duplicate by checking if it matches the TracedCallback
  * it is supposed to be equal to.
  */
 #define DUPE(U, T1)                                                                                \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/test/traced/traced-value-callback-typedef-test-suite.cc ns-3.38/src/test/traced/traced-value-callback-typedef-test-suite.cc
--- ns-3.37/src/test/traced/traced-value-callback-typedef-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/test/traced/traced-value-callback-typedef-test-suite.cc	2023-03-16 20:54:23.832869300 -0700
@@ -81,7 +81,7 @@
 
     if (newValue != 1)
     {
-        g_Result += std::string(g_Result == "" ? "" : " | ") + "newValue should be 1";
+        g_Result += std::string(g_Result.empty() ? "" : " | ") + "newValue should be 1";
     }
 } // TracedValueCbSink<>()
 
@@ -217,7 +217,7 @@
         U sink = TracedValueCbSink<T>;
         CreateObject<CheckTvCb<T>>()->Invoke(sink);
 
-        NS_TEST_ASSERT_MSG_EQ(g_Result, "", g_Result);
+        NS_TEST_ASSERT_MSG_EQ(g_Result.empty(), true, g_Result);
         g_Result = "";
 
     } // CheckType<>()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/topology-read/examples/topology-example-sim.cc ns-3.38/src/topology-read/examples/topology-example-sim.cc
--- ns-3.37/src/topology-read/examples/topology-example-sim.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/topology-read/examples/topology-example-sim.cc	2023-03-16 20:54:23.836869200 -0700
@@ -34,31 +34,17 @@
 #include <sstream>
 
 /**
- * \file
  * \ingroup topology
- * Example of TopologyReader: .read in a topology in a specificed format.
- */
-
-//  Document the available input files
-/**
- * \file RocketFuel_toposample_1239_weights.txt
- * Example TopologyReader input file in RocketFuel format;
- * to read this with topology-example-sim.cc use \c --format=Rocket
- */
-/**
- * \file Inet_toposample.txt
- * Example TopologyReader input file in Inet format;
- * to read this with topology-example-sim.cc use \c --format=Inet
- */
-/**
- * \file Inet_small_toposample.txt
- * Example TopologyReader input file in Inet format;
- * to read this with topology-example-sim.cc use \c --format=Inet
- */
-/**
- * \file Orbis_toposample.txt
- * Example TopologyReader input file in Orbis format;
- * to read this with topology-example-sim.cc use \c --format=Orbis
+ * Example of TopologyReader: read in a topology in a specified format.
+ *
+ * This example can be used with the following parameters:
+ *   - <tt>--format=Inet --input=src/topology-read/examples/Inet_small_toposample.txt</tt>
+ *   - <tt>--format=Inet --input=src/topology-read/examples/Inet_toposample.txt</tt>
+ *   - <tt>--format=Orbis --input=src/topology-read/examples/Orbis_toposample.txt</tt>
+ *   - <tt>--format=Rocket
+ *     --input=src/topology-read/examples/RocketFuel_sample_4755.r0.cch_maps.txt</tt>
+ *   - <tt>--format=Rocket
+ *     --input=src/topology-read/examples/RocketFuel_toposample_1239_weights.txt</tt>
  */
 
 using namespace ns3;
@@ -87,6 +73,8 @@
     std::string format("Inet");
     std::string input("src/topology-read/examples/Inet_small_toposample.txt");
 
+    LogComponentEnable("TopologyCreationExperiment", LOG_LEVEL_INFO);
+
     // Set up command line parameters used to control the experiment.
     CommandLine cmd(__FILE__);
     cmd.AddValue("format", "Format to use for data input [Orbis|Inet|Rocketfuel].", format);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/topology-read/model/inet-topology-reader.cc ns-3.38/src/topology-read/model/inet-topology-reader.cc
--- ns-3.37/src/topology-read/model/inet-topology-reader.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/topology-read/model/inet-topology-reader.cc	2023-03-16 20:54:23.836869200 -0700
@@ -21,6 +21,7 @@
 #include "inet-topology-reader.h"
 
 #include "ns3/log.h"
+#include "ns3/names.h"
 #include "ns3/node-container.h"
 
 #include <cstdlib>
@@ -35,7 +36,6 @@
 
 namespace ns3
 {
-
 NS_LOG_COMPONENT_DEFINE("InetTopologyReader");
 
 NS_OBJECT_ENSURE_REGISTERED(InetTopologyReader);
@@ -117,6 +117,8 @@
             {
                 NS_LOG_INFO("Node " << nodesNumber << " name: " << from);
                 Ptr<Node> tmpNode = CreateObject<Node>();
+                std::string nodeName = "InetTopology/NodeName/" + from;
+                Names::Add(from, tmpNode);
                 nodeMap[from] = tmpNode;
                 nodes.Add(tmpNode);
                 nodesNumber++;
@@ -126,6 +128,8 @@
             {
                 NS_LOG_INFO("Node " << nodesNumber << " name: " << to);
                 Ptr<Node> tmpNode = CreateObject<Node>();
+                std::string nodename = "InetTopology/NodeName/" + to;
+                Names::Add(nodename, tmpNode);
                 nodeMap[to] = tmpNode;
                 nodes.Add(tmpNode);
                 nodesNumber++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/topology-read/model/orbis-topology-reader.cc ns-3.38/src/topology-read/model/orbis-topology-reader.cc
--- ns-3.37/src/topology-read/model/orbis-topology-reader.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/topology-read/model/orbis-topology-reader.cc	2023-03-16 20:54:23.836869200 -0700
@@ -21,6 +21,7 @@
 #include "orbis-topology-reader.h"
 
 #include "ns3/log.h"
+#include "ns3/names.h"
 #include "ns3/node-container.h"
 
 #include <cstdlib>
@@ -99,6 +100,8 @@
             if (!nodeMap[from])
             {
                 Ptr<Node> tmpNode = CreateObject<Node>();
+                std::string nodename = "OrbisTopology/NodeName/" + from;
+                Names::Add(nodename, tmpNode);
                 nodeMap[from] = tmpNode;
                 nodes.Add(tmpNode);
                 nodesNumber++;
@@ -107,6 +110,8 @@
             if (!nodeMap[to])
             {
                 Ptr<Node> tmpNode = CreateObject<Node>();
+                std::string nodename = "OrbisTopology/NodeName/" + to;
+                Names::Add(nodename, tmpNode);
                 nodeMap[to] = tmpNode;
                 nodes.Add(tmpNode);
                 nodesNumber++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/topology-read/model/rocketfuel-topology-reader.cc ns-3.38/src/topology-read/model/rocketfuel-topology-reader.cc
--- ns-3.37/src/topology-read/model/rocketfuel-topology-reader.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/topology-read/model/rocketfuel-topology-reader.cc	2023-03-16 20:54:23.836869200 -0700
@@ -20,6 +20,7 @@
 #include "rocketfuel-topology-reader.h"
 
 #include "ns3/log.h"
+#include "ns3/names.h"
 #include "ns3/node-container.h"
 
 #include <cstdlib>
@@ -87,13 +88,13 @@
  * Build a Regex object for RocketFuel topology maps file type
  * \return a static regex object for maps file type
  */
-static const std::regex rocketfuel_maps_regex(ROCKETFUEL_MAPS_LINE, std::regex::extended);
+static const std::regex rocketfuel_maps_regex(ROCKETFUEL_MAPS_LINE);
 
 /**
  * Build a Regex object for RocketFuel topology weights file type
  * \return a static regex object for weights file type
  */
-static const std::regex rocketfuel_weights_regex(ROCKETFUEL_WEIGHTS_LINE, std::regex::extended);
+static const std::regex rocketfuel_weights_regex(ROCKETFUEL_WEIGHTS_LINE);
 
 /**
  * \brief Print node info
@@ -212,6 +213,8 @@
         if (!m_nodeMap[uid])
         {
             Ptr<Node> tmpNode = CreateObject<Node>();
+            std::string nodename = "RocketFuelTopology/NodeName/" + uid;
+            Names::Add(nodename, tmpNode);
             m_nodeMap[uid] = tmpNode;
             nodes.Add(tmpNode);
             m_nodesNumber++;
@@ -227,6 +230,8 @@
             if (!m_nodeMap[nuid])
             {
                 Ptr<Node> tmpNode = CreateObject<Node>();
+                std::string nodename = "RocketFuelTopology/NodeName/" + nuid;
+                Names::Add(nodename, tmpNode);
                 m_nodeMap[nuid] = tmpNode;
                 nodes.Add(tmpNode);
                 m_nodesNumber++;
@@ -270,6 +275,8 @@
         if (!m_nodeMap[sname])
         {
             Ptr<Node> tmpNode = CreateObject<Node>();
+            std::string nodename = "RocketFuelTopology/NodeName/" + sname;
+            Names::Add(nodename, tmpNode);
             m_nodeMap[sname] = tmpNode;
             nodes.Add(tmpNode);
             m_nodesNumber++;
@@ -278,6 +285,8 @@
         if (!m_nodeMap[tname])
         {
             Ptr<Node> tmpNode = CreateObject<Node>();
+            std::string nodename = "RocketFuelTopology/NodeName/" + tname;
+            Names::Add(nodename, tmpNode);
             m_nodeMap[tname] = tmpNode;
             nodes.Add(tmpNode);
             m_nodesNumber++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/topology-read/test/rocketfuel-topology-reader-test-suite.cc ns-3.38/src/topology-read/test/rocketfuel-topology-reader-test-suite.cc
--- ns-3.37/src/topology-read/test/rocketfuel-topology-reader-test-suite.cc	2022-11-01 17:37:24.719395600 -0700
+++ ns-3.38/src/topology-read/test/rocketfuel-topology-reader-test-suite.cc	2023-03-16 20:54:23.836869200 -0700
@@ -33,8 +33,9 @@
 using namespace ns3;
 
 /**
- * \ingroup topology
  * \defgroup topology-test Topology module tests
+ * \ingroup topology
+ * \ingroup tests
  */
 
 /**
@@ -45,7 +46,6 @@
 
 /**
  * \ingroup topology-test
- * \ingroup tests
 
  * \brief Rocketfuel Topology Reader Weights Test
  */
@@ -90,8 +90,6 @@
 
 /**
  * \ingroup topology-test
- * \ingroup tests
-
  * \brief Rocketfuel Topology Reader Maps Test
  */
 class RocketfuelTopologyReaderMapsTest : public TestCase
@@ -135,7 +133,6 @@
 
 /**
  * \ingroup topology-test
- * \ingroup tests
  *
  * \brief Rocketfuel Topology Reader TestSuite
  */
@@ -154,5 +151,8 @@
     AddTestCase(new RocketfuelTopologyReaderMapsTest(), TestCase::QUICK);
 }
 
-static RocketfuelTopologyReaderTestSuite
-    g_rocketfuelTopologyReaderTestSuite; //!< Static variable for test initialization
+/**
+ * \ingroup topology-test
+ * Static variable for test initialization
+ */
+static RocketfuelTopologyReaderTestSuite g_rocketfuelTopologyReaderTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/examples/codel-vs-pfifo-asymmetric.cc ns-3.38/src/traffic-control/examples/codel-vs-pfifo-asymmetric.cc
--- ns-3.37/src/traffic-control/examples/codel-vs-pfifo-asymmetric.cc	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/examples/codel-vs-pfifo-asymmetric.cc	2023-03-16 20:54:23.836869200 -0700
@@ -71,7 +71,7 @@
 /**
  * TCP Congestion window tracker.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param oldval Old value.
  * \param newval New value.
  */
@@ -90,7 +90,7 @@
 TraceCwnd(std::string cwndTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (cwndTrFileName == "")
+    if (cwndTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for cwnd provided");
         return;
@@ -107,7 +107,7 @@
 /**
  * Traffic Control Sojourn tracker.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param newval New value.
  */
 static void
@@ -125,7 +125,7 @@
 TraceSojourn(std::string sojournTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (sojournTrFileName == "")
+    if (sojournTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for sojourn provided");
         return;
@@ -142,7 +142,7 @@
 /**
  * Traffic Control Queue length tracker.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param oldval Old value.
  * \param newval New value.
  */
@@ -161,7 +161,7 @@
 TraceQueueLength(std::string queueLengthTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (queueLengthTrFileName == "")
+    if (queueLengthTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for queue length provided");
         return;
@@ -178,7 +178,7 @@
 /**
  * Traffic control drop trace.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param item The dropped item.
  */
 static void
@@ -196,7 +196,7 @@
 TraceEveryDrop(std::string everyDropTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (everyDropTrFileName == "")
+    if (everyDropTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for every drop event provided");
         return;
@@ -213,7 +213,7 @@
 /**
  * Traffic Control Dropping state trace.
  *
- * \param stream The ouput stream.
+ * \param stream The output stream.
  * \param oldVal Old value.
  * \param newVal New value.
  */
@@ -241,7 +241,7 @@
 TraceDroppingState(std::string dropStateTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (dropStateTrFileName == "")
+    if (dropStateTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for dropping state provided");
         return;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/examples/codel-vs-pfifo-basic-test.cc ns-3.38/src/traffic-control/examples/codel-vs-pfifo-basic-test.cc
--- ns-3.37/src/traffic-control/examples/codel-vs-pfifo-basic-test.cc	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/examples/codel-vs-pfifo-basic-test.cc	2023-03-16 20:54:23.836869200 -0700
@@ -78,7 +78,7 @@
 TraceCwnd(std::string cwndTrFileName)
 {
     AsciiTraceHelper ascii;
-    if (cwndTrFileName == "")
+    if (cwndTrFileName.empty())
     {
         NS_LOG_DEBUG("No trace file for cwnd provided");
         return;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/examples/fqcodel-l4s-example.cc ns-3.38/src/traffic-control/examples/fqcodel-l4s-example.cc
--- ns-3.37/src/traffic-control/examples/fqcodel-l4s-example.cc	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/examples/fqcodel-l4s-example.cc	2023-03-16 20:54:23.836869200 -0700
@@ -257,7 +257,7 @@
  * ---------------
  *    --n0TcpType:           First TCP type (bic, dctcp, or reno) [bic]
  *    --n1TcpType:           Second TCP type (cubic, dctcp, or reno) []
- *    --scenarioNum:         Scenario number from the scenarios avalaible in the file (1-9) [0]
+ *    --scenarioNum:         Scenario number from the scenarios available in the file (1-9) [0]
  *    --bottleneckQueueType: n2 queue type (fq or codel) [fq]
  *    --baseRtt:             base RTT [80ms]
  *    --useCeThreshold:      use CE threshold [false]
@@ -322,9 +322,10 @@
 }
 
 void
-TracePingRtt(std::ofstream* ofStream, Time rtt)
+TracePingRtt(std::ofstream* ofStream, uint16_t seqNo, Time rtt)
 {
-    *ofStream << Simulator::Now().GetSeconds() << " " << rtt.GetSeconds() * 1000 << std::endl;
+    *ofStream << Simulator::Now().GetSeconds() << " " << seqNo << " " << rtt.GetSeconds() * 1000
+              << std::endl;
 }
 
 void
@@ -531,7 +532,7 @@
     cmd.AddValue("n0TcpType", "n0 TCP type (bic, dctcp, or reno)", n0TcpType);
     cmd.AddValue("n1TcpType", "n1 TCP type (bic, dctcp, or reno)", n1TcpType);
     cmd.AddValue("scenarioNum",
-                 "Scenario number from the scenarios avalaible in the file (1-9)",
+                 "Scenario number from the scenarios available in the file (1-9)",
                  scenarioNum);
     cmd.AddValue("bottleneckQueueType", "n2 queue type (fq or codel)", queueType);
     cmd.AddValue("baseRtt", "base RTT", baseRtt);
@@ -612,7 +613,7 @@
             enableN1Tcp = true;
             n1TcpTypeId = TypeId::LookupByName("ns3::TcpDctcp");
         }
-        else if (n1TcpType == "")
+        else if (n1TcpType.empty())
         {
             NS_LOG_DEBUG("No N1 TCP selected");
         }
@@ -816,12 +817,12 @@
     // application setup                                      //
     ////////////////////////////////////////////////////////////
 
-    V4PingHelper pingHelper("192.168.1.2");
+    PingHelper pingHelper(Ipv4Address("192.168.1.2"));
     pingHelper.SetAttribute("Interval", TimeValue(pingInterval));
     pingHelper.SetAttribute("Size", UintegerValue(pingSize));
     ApplicationContainer pingContainer = pingHelper.Install(pingServer);
-    Ptr<V4Ping> v4Ping = pingContainer.Get(0)->GetObject<V4Ping>();
-    v4Ping->TraceConnectWithoutContext("Rtt", MakeBoundCallback(&TracePingRtt, &pingOfStream));
+    Ptr<Ping> ping = pingContainer.Get(0)->GetObject<Ping>();
+    ping->TraceConnectWithoutContext("Rtt", MakeBoundCallback(&TracePingRtt, &pingOfStream));
     pingContainer.Start(Seconds(1));
     pingContainer.Stop(stopTime - Seconds(1));
 
@@ -935,4 +936,6 @@
     lengthOfStream.close();
     queueDelayN0OfStream.close();
     queueDelayN1OfStream.close();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/model/cobalt-queue-disc.cc ns-3.38/src/traffic-control/model/cobalt-queue-disc.cc
--- ns-3.37/src/traffic-control/model/cobalt-queue-disc.cc	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/model/cobalt-queue-disc.cc	2023-03-16 20:54:23.836869200 -0700
@@ -403,7 +403,7 @@
     if (CoDelTimeAfter((now - m_lastUpdateTimeBlue), Time2CoDel(m_target)))
     {
         NS_LOG_LOGIC("inside IF block");
-        m_pDrop = std::min(m_pDrop + m_increment, (double)1.0);
+        m_pDrop = std::min(m_pDrop + m_increment, 1.0);
         m_lastUpdateTimeBlue = now;
     }
     m_dropping = true;
@@ -421,7 +421,7 @@
     NS_LOG_FUNCTION(this);
     if (m_pDrop && CoDelTimeAfter((now - m_lastUpdateTimeBlue), Time2CoDel(m_target)))
     {
-        m_pDrop = std::max(m_pDrop - m_decrement, (double)0.0);
+        m_pDrop = std::max(m_pDrop - m_decrement, 0.0);
         m_lastUpdateTimeBlue = now;
     }
     m_dropping = false;
@@ -452,7 +452,7 @@
 
     // If L4S mode is enabled then check if the packet is ECT1 or CE and
     // if sojourn time is greater than CE threshold then the packet is marked.
-    // If packet is marked succesfully then the CoDel steps can be skipped.
+    // If packet is marked successfully then the CoDel steps can be skipped.
     if (item && m_useL4s)
     {
         uint8_t tosByte = 0;
@@ -534,7 +534,7 @@
     if (CoDelTimeAfter(sojournTime, Time2CoDel(m_blueThreshold)) &&
         CoDelTimeAfter((now - m_lastUpdateTimeBlue), Time2CoDel(m_target)))
     {
-        m_pDrop = std::min(m_pDrop + m_increment, (double)1.0);
+        m_pDrop = std::min(m_pDrop + m_increment, 1.0);
         m_lastUpdateTimeBlue = now;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/model/cobalt-queue-disc.h ns-3.38/src/traffic-control/model/cobalt-queue-disc.h
--- ns-3.37/src/traffic-control/model/cobalt-queue-disc.h	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/model/cobalt-queue-disc.h	2023-03-16 20:54:23.836869200 -0700
@@ -216,7 +216,7 @@
 
     /**
      * Called to decide whether the current packet should be dropped based on decisions taken by
-     * Blue and Codel working parallely
+     * Blue and Codel working parallelly
      *
      * \return true if the packet should be dropped, false otherwise
      * \param item current packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/model/traffic-control-layer.cc ns-3.38/src/traffic-control/model/traffic-control-layer.cc
--- ns-3.37/src/traffic-control/model/traffic-control-layer.cc	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/model/traffic-control-layer.cc	2023-03-16 20:54:23.840869200 -0700
@@ -111,7 +111,7 @@
 {
     NS_LOG_FUNCTION(this << protocolType << device);
 
-    struct ProtocolHandlerEntry entry;
+    ProtocolHandlerEntry entry;
     entry.handler = handler;
     entry.protocol = protocolType;
     entry.device = device;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/model/traffic-control-layer.h ns-3.38/src/traffic-control/model/traffic-control-layer.h
--- ns-3.37/src/traffic-control/model/traffic-control-layer.h	2022-11-01 17:37:24.723395800 -0700
+++ ns-3.38/src/traffic-control/model/traffic-control-layer.h	2023-03-16 20:54:23.840869200 -0700
@@ -36,8 +36,10 @@
 class NetDeviceQueueInterface;
 
 /**
- * \defgroup traffic-control
- *
+ * \defgroup traffic-control Traffic Control model
+ */
+
+/**
  * The Traffic Control layer aims at introducing an equivalent of the Linux Traffic
  * Control infrastructure into ns-3. The Traffic Control layer sits in between
  * the NetDevices (L2) and any network protocol (e.g., IP). It is in charge of
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/test/adaptive-red-queue-disc-test-suite.cc ns-3.38/src/traffic-control/test/adaptive-red-queue-disc-test-suite.cc
--- ns-3.37/src/traffic-control/test/adaptive-red-queue-disc-test-suite.cc	2022-11-01 17:37:24.727395800 -0700
+++ ns-3.38/src/traffic-control/test/adaptive-red-queue-disc-test-suite.cc	2023-03-16 20:54:23.840869200 -0700
@@ -31,12 +31,12 @@
 
 /**
  * \ingroup traffic-control
+ * \ingroup tests
  * \defgroup traffic-control-test traffic-control module tests
  */
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Ared Queue Disc Test Item
  */
@@ -83,7 +83,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Ared Queue Disc Test Case
  */
@@ -413,7 +412,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Ared Queue Disc Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/test/cobalt-queue-disc-test-suite.cc ns-3.38/src/traffic-control/test/cobalt-queue-disc-test-suite.cc
--- ns-3.37/src/traffic-control/test/cobalt-queue-disc-test-suite.cc	2022-11-01 17:37:24.727395800 -0700
+++ ns-3.38/src/traffic-control/test/cobalt-queue-disc-test-suite.cc	2023-03-16 20:54:23.840869200 -0700
@@ -34,7 +34,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Cobalt Queue Disc Test Item
  */
@@ -46,10 +45,9 @@
      *
      * \param p packet
      * \param addr address
-     * \param protocol protocol
      * \param ecnCapable ECN capable
      */
-    CobaltQueueDiscTestItem(Ptr<Packet> p, const Address& addr, uint16_t protocol, bool ecnCapable);
+    CobaltQueueDiscTestItem(Ptr<Packet> p, const Address& addr, bool ecnCapable);
     ~CobaltQueueDiscTestItem() override;
 
     // Delete default constructor, copy constructor and assignment operator to avoid misuse
@@ -66,9 +64,8 @@
 
 CobaltQueueDiscTestItem::CobaltQueueDiscTestItem(Ptr<Packet> p,
                                                  const Address& addr,
-                                                 uint16_t protocol,
                                                  bool ecnCapable)
-    : QueueDiscItem(p, addr, ecnCapable),
+    : QueueDiscItem(p, addr, 0),
       m_ecnCapablePacket(ecnCapable)
 {
 }
@@ -94,7 +91,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 1: simple enqueue/dequeue with no drops
  */
@@ -177,27 +173,27 @@
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           0 * modeSize,
                           "There should be no packets in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p1, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p1, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           1 * modeSize,
                           "There should be one packet in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p2, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p2, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           2 * modeSize,
                           "There should be two packets in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p3, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p3, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           3 * modeSize,
                           "There should be three packets in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p4, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p4, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           4 * modeSize,
                           "There should be four packets in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p5, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p5, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           5 * modeSize,
                           "There should be five packets in queue");
-    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p6, dest, 0, false));
+    queue->Enqueue(Create<CobaltQueueDiscTestItem>(p6, dest, false));
     NS_TEST_ASSERT_MSG_EQ(queue->GetCurrentSize().GetValue(),
                           6 * modeSize,
                           "There should be six packets in queue");
@@ -265,7 +261,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 2: Cobalt Queue Disc Drop Test Item
  */
@@ -372,7 +367,7 @@
     Address dest;
     for (uint32_t i = 0; i < nPkt; i++)
     {
-        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, 0, true));
+        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, true));
     }
 }
 
@@ -386,7 +381,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 3: Cobalt Queue Disc ECN marking Test Item
  */
@@ -632,7 +626,7 @@
     Address dest;
     for (uint32_t i = 0; i < nPkt; i++)
     {
-        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, 0, ecnCapable));
+        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, ecnCapable));
     }
 }
 
@@ -840,7 +834,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 4: Cobalt Queue Disc CE Threshold marking Test Item
  */
@@ -905,7 +898,7 @@
     Address dest;
     for (uint32_t i = 0; i < nPkt; i++)
     {
-        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, 0, true));
+        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, true));
     }
 }
 
@@ -1005,7 +998,7 @@
     Time dequeueInterval = MicroSeconds(1100);
     DequeueWithDelay(queue, modeSize, 11, dequeueInterval);
 
-    // First mark occured for the packet enqueued at 11ms, ideally TCP would decrease sending rate
+    // First mark occurred for the packet enqueued at 11ms, ideally TCP would decrease sending rate
     // which can be simulated by increasing interval between subsequent enqueues, so packets are now
     // enqueued with a delay 1.2ms.
     Time waitUntilFirstMark = MilliSeconds(11);
@@ -1052,7 +1045,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 5: Cobalt Queue Disc Enhanced Blue Test Item
  * This test checks that the Blue Enhancement is working correctly. This test checks that Pdrop
@@ -1176,7 +1168,7 @@
     Address dest;
     for (uint32_t i = 0; i < nPkt; i++)
     {
-        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, 0, true));
+        queue->Enqueue(Create<CobaltQueueDiscTestItem>(Create<Packet>(size), dest, true));
     }
 }
 
@@ -1201,6 +1193,7 @@
 }
 
 /**
+ * \ingroup traffic-control-test
  * The COBALT queue disc test suite.
  */
 static class CobaltQueueDiscTestSuite : public TestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/test/codel-queue-disc-test-suite.cc ns-3.38/src/traffic-control/test/codel-queue-disc-test-suite.cc
--- ns-3.37/src/traffic-control/test/codel-queue-disc-test-suite.cc	2022-11-01 17:37:24.727395800 -0700
+++ ns-3.38/src/traffic-control/test/codel-queue-disc-test-suite.cc	2023-03-16 20:54:23.840869200 -0700
@@ -58,7 +58,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Codel Queue Disc Test Item
  */
@@ -88,7 +87,7 @@
 };
 
 CodelQueueDiscTestItem::CodelQueueDiscTestItem(Ptr<Packet> p, const Address& addr, bool ecnCapable)
-    : QueueDiscItem(p, addr, ecnCapable),
+    : QueueDiscItem(p, addr, 0),
       m_ecnCapablePacket(ecnCapable)
 {
 }
@@ -114,7 +113,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 1: simple enqueue/dequeue with no drops
  */
@@ -277,7 +275,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 2: enqueue with drops due to queue overflow
  */
@@ -369,7 +366,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 3: NewtonStep unit test - test against explicit port of Linux implementation
  */
@@ -408,7 +404,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 4: ControlLaw unit test - test against explicit port of Linux implementation
  */
@@ -440,7 +435,7 @@
     return t + _reciprocal_scale(interval, recInvSqrt << REC_INV_SQRT_SHIFT_ns3);
 }
 
-// End Linux borrrow
+// End Linux borrow
 
 void
 CoDelQueueDiscControlLawTest::DoRun()
@@ -467,7 +462,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 5: enqueue/dequeue with drops according to CoDel algorithm
  */
@@ -680,7 +674,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Test 6: enqueue/dequeue with marks according to CoDel algorithm
  */
@@ -1132,7 +1125,7 @@
                         nPacketsBeforeFirstMark,
                         "Number of packets in the queue before drop should be equal"
                         "to number of packets in the queue before first mark as the behavior "
-                        "untill packet N should be the same.");
+                        "until packet N should be the same.");
                     NS_TEST_ASSERT_MSG_EQ(
                         currentCeThreshMarkCount,
                         0,
@@ -1333,7 +1326,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief CoDel Queue Disc Test Suite
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/traffic-control/test/fifo-queue-disc-test-suite.cc ns-3.38/src/traffic-control/test/fifo-queue-disc-test-suite.cc
--- ns-3.37/src/traffic-control/test/fifo-queue-disc-test-suite.cc	2022-11-01 17:37:24.727395800 -0700
+++ ns-3.38/src/traffic-control/test/fifo-queue-disc-test-suite.cc	2023-03-16 20:54:23.840869200 -0700
@@ -35,7 +35,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Fifo Queue Disc Test Item
  */
@@ -82,7 +81,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Fifo Queue Disc Test Case
  */
@@ -269,7 +267,6 @@
 
 /**
  * \ingroup traffic-control-test
- * \ingroup tests
  *
  * \brief Fifo Queue Disc Test Suite
  */
